#ifndef _AARON_H_
#define _AARON_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Choose some numbers for your settings.
// Never choose the same number for two different settings
// (even in different plugins: in a given group of plugins,
// all settings should have different ID numbers).
// If you want to write several plugins, just write all the
// ID numbers you have already used in each plugin you have written
// for being sure not to use the same twice.
#define AARON_ENABLED	        71
#define AARON_REFWHITE         72
#define AARON_DUMP	        73
#define AARON_XMUL         74
#define AARON_YMUL         75
#define AARON_ADAPTENABLE         76
#define AARON_TARGETWHITE         77
#define AARON_ADAPTMETHOD         78
#define AARON_SYNC         79

// Put the same name without space than in the UI
#define AARON_PLUGINNAME	"Aaron"

// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define AARON_PLUGINGROUP	"baruchel"

// Put here the name that will be displayed on the
// selective settings window. For that reason, it has to
// be nice; put spaces for separating words.
#define AARON_GROUP		"Aaron"		

// Put here the name of the button you have defined in the UI
// (without the final "_button" part).
#define	AARON_BUTTONNAME	"aaron_Info"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

#endif // _AARON_H_
