R = ((double) *(pIn))/((double) 652.80);
G = (((double)*(pIn + pw))
  -((double)32768.0))/((double)256.0);
B = (((double)*(pIn + 2*pw))
  -((double)32768.0))/((double)256.0);

double fy = (R+((double)16.0))/((double)116.0);
double fx = G/((double)500.0)+fy;
double fz = fy-B/((double)200.0);
double xr,yr,zr;
double fx3=fx*fx*fx;
double fz3=fz*fz*fz;
if(fx3>EPSILON) xr = fx3;
else xr = (((double)116.0)*fx-((double)16.0))/KAPPA;
if(fz3>EPSILON) zr = fz3;
else zr = (((double)116.0)*fz-((double)16.0))/KAPPA;
if(R>EPSILONKAPPA) {
  yr = ((R+((double)16.0))/((double)116.0));
  yr = yr*yr*yr;
} else yr = R/KAPPA;
double X = xr*white_x;
double Y = yr*white_y;
double Z = zr*white_z;

if(adaptenable) {
  double X2,Y2,Z2;
  X2 = matrix[0]*X+matrix[1]*Y+matrix[2]*Z;
  Y2 = matrix[3]*X+matrix[4]*Y+matrix[5]*Z;
  Z2 = matrix[6]*X+matrix[7]*Y+matrix[8]*Z;
  X = X2; Y = Y2; Z = Z2;
  if(X<(double)0.0) X=0.0;
  else if(X>(double)1.0) X=1.0;
  if(Y<(double)0.0) Y=0.0;
  else if(Y>(double)1.0) Y=1.0;
  if(Z<(double)0.0) Z=0.0;
  else if(Z>(double)1.0) Z=1.0;
}

double little_x;
double little_y;
if(X+Y+Z < ((double)1e-16)) {
  little_x = white_little_x_out;
  little_y = white_little_y_out;
} else {
  little_x = X/(X+Y+Z);
  little_y = Y/(X+Y+Z);
}

// Saturation
little_x = (little_x-white_little_x_out)*xmul+white_little_x_out;
little_y = (little_y-white_little_y_out)*ymul+white_little_y_out;

X = little_x*Y/little_y;
Z = (((double) 1.0) - little_x - little_y)*Y/little_y;

xr = X/white_x_out;
yr = Y/white_y_out;
zr = Z/white_z_out;
if(xr>EPSILON) fx = pow(xr,(double).333333333333333333333333333333);
else fx = (KAPPA*xr+((double)16.0))/((double)116.0);
if(yr>EPSILON) fy = pow(yr,(double).333333333333333333333333333333);
else fy = (KAPPA*yr+((double)16.0))/((double)116.0);
if(zr>EPSILON) fz = pow(zr,(double).333333333333333333333333333333);
else fz = (KAPPA*zr+((double)16.0))/((double)116.0);
R = ((double)116.0)*fy-((double)16.0);
G = ((double)500.0)*(fx-fy);
B = ((double)200.0)*(fy-fz);

R *= (double)652.80;
G = G*((double)256.0)+(double)32768.0;
B = B*((double)256.0)+(double)32768.0;

if(R<(double)0.0) R=(double)0.0;
if(R>(double)65280.0) R=(double)65280.0;
if(G<(double)0.0) G=(double)0.0;
if(G>(double)65535.0) G=(double)65535.0;
if(B<(double)0.0) B=(double)0.0;
if(B>(double)65535.0) B=(double)65535.0;
