#ifndef _BATHSHEBA_H_
#define _BATHSHEBA_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Choose some numbers for your settings.
// Never choose the same number for two different settings
// (even in different plugins: in a given group of plugins,
// all settings should have different ID numbers).
// If you want to write several plugins, just write all the
// ID numbers you have already used in each plugin you have written
// for being sure not to use the same twice.
#define BATHSHEBA_ENABLED	        110
#define BATHSHEBA_REFWHITE         111
#define BATHSHEBA_SPECTRUM         112
#define BATHSHEBA_SELECTCURRENTWL 113
#define BATHSHEBA_ADJUSTCURRENTWL 114
#define BATHSHEBA_NORMALIZE              118
#define BATHSHEBA_YCHANNEL         119
#define BATHSHEBA_WLVALUE350 120
#define BATHSHEBA_WLVALUE360 121
#define BATHSHEBA_WLVALUE370 122
#define BATHSHEBA_WLVALUE380 123
#define BATHSHEBA_WLVALUE390 124
#define BATHSHEBA_WLVALUE400 125
#define BATHSHEBA_WLVALUE410 126
#define BATHSHEBA_WLVALUE420 127
#define BATHSHEBA_WLVALUE430 128
#define BATHSHEBA_WLVALUE440 129
#define BATHSHEBA_WLVALUE450 130
#define BATHSHEBA_WLVALUE460 131
#define BATHSHEBA_WLVALUE470 132
#define BATHSHEBA_WLVALUE480 133
#define BATHSHEBA_WLVALUE490 134
#define BATHSHEBA_WLVALUE500 135
#define BATHSHEBA_WLVALUE510 136
#define BATHSHEBA_WLVALUE520 137
#define BATHSHEBA_WLVALUE530 138
#define BATHSHEBA_WLVALUE540 139
#define BATHSHEBA_WLVALUE550 140
#define BATHSHEBA_WLVALUE560 141
#define BATHSHEBA_WLVALUE570 142
#define BATHSHEBA_WLVALUE580 143
#define BATHSHEBA_WLVALUE590 144
#define BATHSHEBA_WLVALUE600 145
#define BATHSHEBA_WLVALUE610 146
#define BATHSHEBA_WLVALUE620 147
#define BATHSHEBA_WLVALUE630 148
#define BATHSHEBA_WLVALUE640 149
#define BATHSHEBA_WLVALUE650 150
#define BATHSHEBA_WLVALUE660 151
#define BATHSHEBA_WLVALUE670 152
#define BATHSHEBA_WLVALUE680 153
#define BATHSHEBA_WLVALUE690 154
#define BATHSHEBA_WLVALUE700 155
#define BATHSHEBA_WLVALUE710 156
#define BATHSHEBA_WLVALUE720 157
#define BATHSHEBA_WLVALUE730 158
#define BATHSHEBA_WLVALUE740 159
#define BATHSHEBA_WLVALUE750 160
#define BATHSHEBA_WLVALUE760 161
#define BATHSHEBA_WLVALUE770 162
#define BATHSHEBA_WLVALUE780 163

// Put the same name without space than in the UI
#define BATHSHEBA_PLUGINNAME	"Bathsheba"

// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define BATHSHEBA_PLUGINGROUP	"baruchel"

// Put here the name that will be displayed on the
// selective settings window. For that reason, it has to
// be nice; put spaces for separating words.
#define BATHSHEBA_GROUP		"Bathsheba"		

// Put here the name of the button you have defined in the UI
// (without the final "_button" part).
#define	BATHSHEBA_BUTTONNAME	"bathsheba_Info"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

const char *vbar[44] = {
  "bathsheba_curve350_label", "bathsheba_curve360_label",
  "bathsheba_curve370_label", "bathsheba_curve380_label",
  "bathsheba_curve390_label", "bathsheba_curve400_label",
  "bathsheba_curve410_label", "bathsheba_curve420_label",
  "bathsheba_curve430_label", "bathsheba_curve440_label",
  "bathsheba_curve450_label", "bathsheba_curve460_label",
  "bathsheba_curve470_label", "bathsheba_curve480_label",
  "bathsheba_curve490_label", "bathsheba_curve500_label",
  "bathsheba_curve510_label", "bathsheba_curve520_label",
  "bathsheba_curve530_label", "bathsheba_curve540_label",
  "bathsheba_curve550_label", "bathsheba_curve560_label",
  "bathsheba_curve570_label", "bathsheba_curve580_label",
  "bathsheba_curve590_label", "bathsheba_curve600_label",
  "bathsheba_curve610_label", "bathsheba_curve620_label",
  "bathsheba_curve630_label", "bathsheba_curve640_label",
  "bathsheba_curve650_label", "bathsheba_curve660_label",
  "bathsheba_curve670_label", "bathsheba_curve680_label",
  "bathsheba_curve690_label", "bathsheba_curve700_label",
  "bathsheba_curve710_label", "bathsheba_curve720_label",
  "bathsheba_curve730_label", "bathsheba_curve740_label",
  "bathsheba_curve750_label", "bathsheba_curve760_label",
  "bathsheba_curve770_label", "bathsheba_curve780_label"
};



const int indices[44] = {
BATHSHEBA_WLVALUE350, BATHSHEBA_WLVALUE360, BATHSHEBA_WLVALUE370,
BATHSHEBA_WLVALUE380, BATHSHEBA_WLVALUE390, BATHSHEBA_WLVALUE400,
BATHSHEBA_WLVALUE410, BATHSHEBA_WLVALUE420, BATHSHEBA_WLVALUE430,
BATHSHEBA_WLVALUE440, BATHSHEBA_WLVALUE450, BATHSHEBA_WLVALUE460,
BATHSHEBA_WLVALUE470, BATHSHEBA_WLVALUE480, BATHSHEBA_WLVALUE490,
BATHSHEBA_WLVALUE500, BATHSHEBA_WLVALUE510, BATHSHEBA_WLVALUE520,
BATHSHEBA_WLVALUE530, BATHSHEBA_WLVALUE540, BATHSHEBA_WLVALUE550,
BATHSHEBA_WLVALUE560, BATHSHEBA_WLVALUE570, BATHSHEBA_WLVALUE580,
BATHSHEBA_WLVALUE590, BATHSHEBA_WLVALUE600, BATHSHEBA_WLVALUE610,
BATHSHEBA_WLVALUE620, BATHSHEBA_WLVALUE630, BATHSHEBA_WLVALUE640,
BATHSHEBA_WLVALUE650, BATHSHEBA_WLVALUE660, BATHSHEBA_WLVALUE670,
BATHSHEBA_WLVALUE680, BATHSHEBA_WLVALUE690, BATHSHEBA_WLVALUE700,
BATHSHEBA_WLVALUE710, BATHSHEBA_WLVALUE720, BATHSHEBA_WLVALUE730,
BATHSHEBA_WLVALUE740, BATHSHEBA_WLVALUE750, BATHSHEBA_WLVALUE760,
BATHSHEBA_WLVALUE770, BATHSHEBA_WLVALUE780 };

// 2 * h * c^2   / (lambda^5)
const double planck1[44] = {
22677446283940211.0550875801749271137026,
19697987831152449.1396467340683161442192,
17176147000730319.9110620122240788768371,
15031986794605171.6897846168509417434440,
13201136859572699.2545417665608757579549,
11631464834417209.6924700000000000000000,
10280520065078970.3738769062520874476110,
9113557052123605.9088411378660811767387,
8101997237290121.3062227181060614321315,
7222224534102371.1075808284332292255248,
6454636652512034.5340794418195058341377,
5782893713112410.4193800734361111581530,
5193319944586028.2997524685593002685251,
4674424846650434.7079435120884773662551,
4216518095871551.11246199131591879754392,
3811398396941831.27202856960000000000000,
3452100956646568.08700916791739396488404,
3132691657105630.78013051686942657146782,
2848098602163372.12536369443847640892677,
2593973706159993.30234031065920212598772,
2366578535334664.96453208586100055261998,
2162689808267613.51157069970845481049563,
1979520894762820.96326381785691413905435,
1814656383712832.03178446999726831490522,
1665997366029270.00598272852941595149223,
1531715533750414.44509893004115226337448,
1410214557693548.63952799622786886915338,
1300097493989083.74949379393052906109580,
1200139200279651.80692558194121233603144,
1109262927476616.83010768890380859375000,
1026520402200373.09403316776777369893857,
951074835766567.38865261938215364286746,
882186393593465.90723679357516014254818,
819199738735464.88783518340227220065119,
761533328475708.36798420720146319778146,
708670196373131.59547148688046647230320,
660149996110068.97565371000330212453128,
615562119723514.03561396043963487950685,
574539732764705.47465020808859252937532,
536754593772822.497220687882002464901160,
501912546099335.805370017395884773662550,
469749587331411.615305769276591929482626,
440028435944596.181005698120760797699614,
412535526861646.851704430205027367436090
};

// h*c/(lambda *k)
const double planck2[44] = {
41108.1804066373956840993668254793714900,
39966.2865064530235817632733025493889484,
38886.1166008732121336075091592372433012,
37862.7977429554960248283641813625790038,
36891.9567751874063831660984331225128756,
35969.6578558077212235869459722944500536,
35092.3491276172889986214107046775122474,
34256.8170055311630700828056878994762416,
33460.1468426118336963599497416692558639,
32699.6889598252011123517690657222273215,
31973.0292051624188654106186420395111588,
31277.9633528762793248582138889516956988,
30612.4747709001882753931455083357021733,
29974.7148798397676863224549769120417114,
29362.9860047409969172138334467709796357,
28775.7262846461769788695567778355600429,
28211.4963574962519400681929194466274931,
27668.9675813905547873745738248418846566,
27146.9115892888462064807139413543019273,
26644.1910043020157211755155350329259657,
26159.7511678601608898814152525777818572,
25692.6127541483723025621042659246071812,
25241.8651619703306832189094542417193359,
24806.6605902122215335082386015823793474,
24386.2087158018448973470820151148813923,
23979.7719038718141490579639815296333691,
23586.6608890542434253029153916684918385,
23206.2308747146588539270619176093226153,
22837.8780036874420467218704585996508277,
22481.0361598798257647418412326840312835,
22135.1740651124438298996590598735077253,
21799.7926398834674082345127104814848811,
21474.4226004822216260220572968922089873,
21158.6222681221889550511446895849706198,
20851.9755685841862165721425926344637992,
20554.0902033186978420496834127396857450,
20264.5959751029415344151808294616620021,
19983.1432532265117908816366512746944742,
19709.4015648261486156640799848188767418,
19443.0583004366060668037545796186216506,
19183.8175230974513192463711852237066953,
18931.3988714777480124141820906812895019,
18685.5365484715434927724394661269870409,
18445.9783875937031915830492165612564378
};


#endif // _BATHSHEBA_H_
