#ifndef _BATHSHEBASOLOMON_H_
#define _BATHSHEBASOLOMON_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Choose some numbers for your settings.
// Never choose the same number for two different settings
// (even in different plugins: in a given group of plugins,
// all settings should have different ID numbers).
// If you want to write several plugins, just write all the
// ID numbers you have already used in each plugin you have written
// for being sure not to use the same twice.
#define BATHSHEBA_ENABLED	        91
#define BATHSHEBA_REFWHITE         92
#define BATHSHEBA_S1             93 
#define BATHSHEBA_S2              94
#define BATHSHEBA_NORMALIZE              95
#define BATHSHEBA_YCHANNEL         96
#define BATHSHEBA_RESETOPT         97

// Put the same name without space than in the UI
#define BATHSHEBA_PLUGINNAME	"BathshebaSolomon"

// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define BATHSHEBA_PLUGINGROUP	"baruchel"

// Put here the name that will be displayed on the
// selective settings window. For that reason, it has to
// be nice; put spaces for separating words.
#define BATHSHEBA_GROUP		"Bathsheba (Solomon version)"

// Put here the name of the button you have defined in the UI
// (without the final "_button" part).
#define	BATHSHEBA_BUTTONNAME	"bathshebaS_Info"
#define	BATHSHEBA_RESET	"bathshebaS_Reset"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

#endif // _BATHSHEBASOLOMON_H_
