#ifndef _LABCOLORS_H_
#define _LABCOLORS_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Define the settings strings - these must match the prefixes on the controls
// for the option system to work properly
#define LC_ENABLED	50
#define LC_AMUL     51
#define LC_BMUL     52
#define LC_AADD     53
#define LC_BADD     54

#define LC_PLUGINNAME	"LabColors"
#define LC_PLUGINGROUP	"baruchel"// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define LC_GROUP		"Lab Colors"		

#define	LC_BUTTONNAME	"lcButton"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

#endif // _LABCOLORS_H_
