#ifndef _LABCONTRAST_H_
#define _LABCONTRAST_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Define the settings strings - these must match the prefixes on the controls
// for the option system to work properly
#define LCO_ENABLED	60
#define LCO_MIDDLEGRAY  61
#define LCO_CONTRAST    62
#define LCO_EXPOSURE    63
#define LCO_DETAILS     64
#define LCO_RGB    65

#define LCO_PLUGINNAME	"LabContrast"
#define LCO_PLUGINGROUP	"baruchel"// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define LCO_GROUP		"Lab Contrast"		

#define	LCO_BUTTONNAME	"lcoButton"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

#endif // _LABCONTRAST_H_
