#ifndef _NEGATIVEPOSITIVE_H_
#define _NEGATIVEPOSITIVE_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Define the settings strings - these must match the prefixes on the controls
// for the option system to work properly
#define NP_ENABLED	20
#define NP_BPC	28
#define NP_GAMMA	90

#define NP_PLUGINNAME	"NegativePositive"
#define NP_PLUGINGROUP	"baruchel"// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define NP_GROUP		"Negative to Positive"		

#define	NP_BUTTONNAME	"negativepositive_Button"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

#endif // _NEGATIVEPOSITIVE_H_
