#ifndef _SELECTCOLOR_H_
#define _SELECTCOLOR_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Define the settings strings - these must match the prefixes on the controls
// for the option system to work properly
#define SC_ENABLED	0
#define SC_RESETOPT     1
#define SC_DW     2
#define SC_PREVIEW     3
#define SC_CALIBRATE     4
#define SC_RADIUS     5
#define SC_FULLRANGE     6
#define SC_HUE     7
#define SC_XMUL     8
#define SC_YMUL     9
#define SC_AMUL     18
#define SC_BMUL     19
#define SC_AADD     48
#define SC_BADD     49
#define SC_XADD     57
#define SC_YADD     58
#define SC_MIDDLEGRAY     59
#define SC_CONTRAST     67
#define SC_EXPOSURE     68
#define SC_GAMMA     69
#define SC_LCHANNEL     89

#define SC_PLUGINNAME	"SelectColor"
// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define SC_PLUGINGROUP	"baruchel"
#define SC_GROUP		"Select Color"

#define	SC_BUTTONNAME	"selectcolor_Button"
#define	SC_RESET	"selectcolor_Reset"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

#endif // _SELECTCOLOR_H_
