double L = ((double)*(pIn))/652.80;
double a = (((double)*(pIn + pw))-((double)32768))/256.0;
double b = (((double)*(pIn + 2*pw))-((double)32768))/256.0;
double fy = (L+((double)16.0))/((double)116.0);
double fx = a/((double)500.0)+fy;
double fz = fy-b/((double)200.0);
double xr,yr,zr;
double fx3=fx*fx*fx;
double fz3=fz*fz*fz;
if(fx3>EPSILON) xr = fx3;
else xr = (((double)116.0)*fx-((double)16.0))/KAPPA;
if(fz3>EPSILON) zr = fz3;
else zr = (((double)116.0)*fz-((double)16.0))/KAPPA;
if(L>EPSILONKAPPA) {
  yr = ((L+((double)16.0))/((double)116.0));
  yr = yr*yr*yr;
} else yr = L/KAPPA;
double X = xr*white_x;
double Y = yr*white_y;
double Z = zr*white_z;
double little_x = X/(X+Y+Z);
double little_y = Y/(X+Y+Z);
double dy = little_y-little_y_white;
double dx = little_x-little_x_white;
double at = atan2(dy,dx);
double theta;
if(at<dw_arct) { theta = dw_arct-at; }
else { theta = at-dw_arct; }
if( theta > PI) theta = DPI-theta;

double proximity;
if(fullrange) {
  // theta = 0 ---> proximity = 1
  // theta = Pi ---> proximity = 0
  proximity=pow(cos(theta/2),proximity_gamma);
} else {
  if(theta > proximity_setting) { proximity = 0.0; }
  else {
    proximity = pow(cos(HPI*theta/proximity_setting),proximity_gamma);
  }
}

/* LERP(a,b,c) = linear interpolation macro,
   is 'a' when c == 0.0 and 'b' when c == 1.0 */
#define LERP(a,b,c)     (((b) - (a)) * (c) + (a))

if(preview) {
  // preview mode
  L = 65280.0*proximity;
  a = 32768.0;
  b = 32768.0;
} else {
  // normal mode
  if(hue!= 0) {
    double distance = sqrt( dx*dx+dy*dy );
    double radian = at + hue*DEGTORAD;
    dx = LERP(dx,distance*cos(radian),proximity);
    dy = LERP(dy,distance*sin(radian),proximity);
  }
  little_x = little_x_white + dx * LERP(1.0,xmul,proximity)
           + xadd*proximity;
  little_y = little_y_white + dy * LERP(1.0,ymul,proximity)
           + yadd*proximity;

  // change Y
  if(!lchannel) {
    double value;
    if(contrast>0.005) {
    value = (((double) 1.0) / (
      ((double) 1.0)+
      exp(beta-contrast*pow(Y*exposure, gamma))) - c1)/c2;
    } else {
      value = pow(Y*exposure, gamma);
    }
    Y = LERP(Y,value,proximity);
  }

  // xyY to XYZ
  X = little_x*Y/little_y;
  Z = (1-little_x-little_y)*Y/little_y;


  // XYZ to Lab
  xr = X/white_x;
  yr = Y/white_y;
  zr = Z/white_z;
  if(xr>EPSILON) fx = pow(xr,(double).333333333333333333333333333333333);
  else fx = (KAPPA*xr+((double)16.0))/((double)116.0);
  if(yr>EPSILON) fy = pow(yr,(double).333333333333333333333333333333333);
  else fy = (KAPPA*yr+((double)16.0))/((double)116.0);
  if(zr>EPSILON) fz = pow(zr,(double).333333333333333333333333333333333);
  else fz = (KAPPA*zr+((double)16.0))/((double)116.0);
  L = ((double)116.0)*fy-((double)16.0);
  a = ((double)500.0)*(fx-fy);
  b = ((double)200.0)*(fy-fz);

  a *= LERP(1.0,amul,proximity) + aadd*proximity;
  b *= LERP(1.0,bmul,proximity) + badd*proximity;
  
  // change L
  if(lchannel) {
    double value;
    if(contrast>0.005) {
    value = ((double) 100.0)*
      (((double) 1.0) / (
      ((double) 1.0)+
      exp(beta-contrast*pow(L/((double)100.0)*exposure, gamma))) - c1)/c2;
    } else {
      value = ((double) 100.0)*
        pow(L/((double)100.0)*exposure, gamma);
    }
    L = LERP(L,value,proximity);
  }


  // Final encoding
  L *= (double)652.80;
  a = a*((double)256.0)+32768.0;
  b = b*((double)256.0)+32768.0;
  if(L<0.0) { L = 0.0; } else { if(L>65280.0) { L = 65280.0; } }
  if(a<0.0) { a = 0.0; } else { if(a>65535.0) { a = 65535.0; } }
  if(b<0.0) { b = 0.0; } else { if(b>65535.0) { b = 65535.0; } }
}
