#ifndef _SIMPLEFRAME_H_
#define _SIMPLEFRAME_H_
#include <string>
#include <cmath>

#include "BibblePlugin.h"

using namespace std;

#if defined( __GNUC__ ) && ( __GNUC__ >= 4 )
#	define __declspec( a ) __attribute__( ( visibility( "default" ) ) )
#elif !defined( WIN32 )
#	define __declspec( a )
#endif

// Export functions to register the plug-in with Bibble
extern "C" {
__declspec(dllexport) int unRegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int RegisterPlugin(struct BibblePluginData *bibbleData);
__declspec(dllexport) int getVersion( void );
__declspec(dllexport) bool runCheck(struct BibblePluginData *bibbleData, struct BPluginPipeData *pipeData, BBOOL &needPrev );
__declspec(dllexport) int buildDefaults(struct BibblePluginData *bibbleData, struct BAddOptionFunctions *baf );
}

// Choose some numbers for your settings.
// Never choose the same number for two different settings
// (even in different plugins: in a given group of plugins,
// all settings should have different ID numbers).
// If you want to write several plugins, just write all the
// ID numbers you have already used in each plugin you have written
// for being sure not to use the same twice.
#define SF_ENABLED	        171
#define SF_WIDTH      172
#define SF_RADIUS      173
#define SF_THRESHOLD     174
#define SF_COLOR  175

// Put the same name without space than in the UI
#define SF_PLUGINNAME	"SimpleFramePlugin"

// The  plugin group/owner name  for all of yout plug-in's settings keep it short but unique
#define SF_PLUGINGROUP	"baruchel"

// Put here the name that will be displayed on the
// selective settings window. For that reason, it has to
// be nice; put spaces for separating words.
#define SF_GROUP		"Simple Frame Plugin"		

// Put here the name of the button you have defined in the UI
// (without the final "_button" part).
#define	SF_BUTTONNAME	"sf_Info"

// Grab a pointer to the debug trace function and define a macro to simplify using it
typedef void (*BDebugTraceFunction)(const char *msg);
extern BDebugTraceFunction BTestDebug;
#define BMSG(A)  if (BTestDebug) { BTestDebug(A); } 

inline unsigned int SfSetColor( int R, int G, int B )
{ return ( 0xff000000 + (((unsigned int)R)<<16) + (((unsigned int)G)<<8) + ((unsigned int)B) );}

inline int SfGetRed( unsigned int rgb )		// get red part of RGB (8 bit value)
{ return (int)((rgb >> 16) & 0xff); }

inline int SfGetGreen( unsigned int rgb )		// get green part of RGB
{ return (int)((rgb >> 8) & 0xff); }

inline int SfGetBlue( unsigned int rgb )		// get blue part of RGB
{ return (int)(rgb & 0xff); }

#endif // _SIMPLEFRAME_H_
